extends KinematicBody2D

var motion : Vector2 = Vector2(0, 0)
var up : Vector2 = Vector2(0, -1)
var jumpkorrekt : bool = false
var walking_speed : int = 90
var walking_speed2 : int = -90

var winter_moving : bool = false
var ice_moving : int = 0
var ice_move_speed : int = 250

var window_change_action : bool = false

func _ready():

#	Performance-Tests
#	var time_start = OS.get_ticks_usec()
#
#	readybeady()
#
#	var time_end = OS.get_ticks_usec()
#	$Label.text = str(time_end - time_start)
#
#func readybeady():
#	for i in 500000:
#		pass

	if Globals.power == true:
		walking_speed = 250
		walking_speed2 = -250

	else:
		walking_speed = 90
		walking_speed2 = -90

	if Globals.appearance == 0:
		pass

	elif Globals.appearance == 1:
		$AnimatedSprite.set_self_modulate(Color(1, 1, 1, 0.25))

	elif Globals.appearance == 2:
		$AnimatedSprite.set_self_modulate(Color(0, 1, 1, 1))

	else:
		$AnimatedSprite.set_self_modulate(Color(1, 1, 1, 0))

	if Globals.DeathCountOn == false:
		$TextureRect/Label.text = ""

	else:
		$TextureRect/Label.text = str(Globals.deathcount)

	if Globals.soundsetting == 3:
		$AudioStreamPlayer1.volume_db = 7

	elif Globals.soundsetting == 4:
		$AudioStreamPlayer1.volume_db = 14

	elif Globals.soundsetting == 2:
		$AudioStreamPlayer1.volume_db = 0

	elif Globals.soundsetting == 1:
		$AudioStreamPlayer1.volume_db = -7

	if Globals.intro_zoom == false:
		$Camera2D.zoom = Vector2(1, 1)

	elif Globals.ice_world_view == true:
		$Camera2D.zoom = Vector2(2, 2)

	elif Globals.waytodestroysun == true or Globals.underground_zoom == true:
		$Camera2D.zoom = Vector2(1.5, 1.5)

	else:
		$Camera2D.zoom = Vector2(1.28, 1.28)

func _physics_process(_delta : float):

	if winter_moving == true:

		motion.x = ice_move_speed
		$AnimatedSprite.set_flip_h(false)
		if jumpkorrekt == false:
			$AnimatedSprite.play("Walking")

	move_and_slide(motion, up)
	jump()
	apply_gravity()

	if Globals.fps_show == true:
		$TextureRect/Label2.text = str(Engine.get_frames_per_second())

	else:
		$TextureRect/Label2.text = ""

	if Input.is_action_just_pressed("music_change") and Globals.fkeys == true:

		if Globals.musicsetting == 4:
			Globals.musicsetting = 3
			Globals.saveValue("Values", "Music")

		elif Globals.musicsetting == 3:
			Globals.musicsetting = 2
			Globals.saveValue("Values", "Music")

		elif Globals.musicsetting == 2:
			Globals.musicsetting = 1
			Globals.saveValue("Values", "Music")

		elif Globals.musicsetting == 1:
			Globals.musicsetting = 0
			Globals.saveValue("Values", "Music")

		else:
			Globals.musicsetting = 4
			Globals.saveValue("Values", "Music")
			Globals.music_chosen = false

	elif Input.is_action_just_pressed("sound_change") and Globals.fkeys == true:

		if Globals.soundsetting == 4:
			Globals.soundsetting = 3
			Globals.saveValue("Values", "Sound")
			$AudioStreamPlayer1.volume_db = 7

		elif Globals.soundsetting == 3:
			Globals.soundsetting = 2
			Globals.saveValue("Values", "Sound")
			$AudioStreamPlayer1.volume_db = 0

		elif Globals.soundsetting == 2:
			Globals.soundsetting = 1
			Globals.saveValue("Values", "Sound")
			$AudioStreamPlayer1.volume_db = -7

		elif Globals.soundsetting == 1:
			Globals.soundsetting = 0
			Globals.saveValue("Values", "Sound")

		else:
			Globals.soundsetting = 4
			Globals.saveValue("Values", "Sound")
			$AudioStreamPlayer1.volume_db = 14

	elif Input.is_action_just_pressed("ui_accept") and OS.window_fullscreen == true and Globals.fkeys == true:
		OS.window_fullscreen = false
		Globals.fullscreen = false
		Globals.saveValue("Values", "Fullscreen")

	elif Input.is_action_just_pressed("ui_accept") and OS.window_fullscreen == false and Globals.fkeys == true:
		OS.window_fullscreen = true
		Globals.fullscreen = true

	elif Input.is_action_just_pressed("ui_end") and Globals.DeathCountOn == true:
		Globals.DeathCountOn = false
		$TextureRect/Label.text = ""
		Globals.saveValue("Values", "DeathCounterOn")

	elif Input.is_action_just_pressed("ui_end") and Globals.DeathCountOn == false:
		Globals.DeathCountOn = true
		$TextureRect/Label.text = str(Globals.deathcount)
		Globals.saveValue("Values", "DeathCounterOn")

	elif Input.is_action_just_pressed("ui_home") and Globals.bunnyhop == true:
		Globals.bunnyhop = false
		Globals.saveValue("Values", "BunnyHop")

	elif Input.is_action_just_pressed("ui_home") and Globals.bunnyhop == false:
		Globals.bunnyhop = true
		Globals.saveValue("Values", "BunnyHop")

	elif Input.is_action_just_pressed("resolution_change") and Globals.fkeys == true:

		if window_change_action == false:

			if Globals.resolution == 1:
				window_change_action = true
				OS.window_fullscreen = false
				Globals.resolution = 2
				OS.window_size = Vector2(1600, 900)
				yield(get_tree().create_timer(0.1), "timeout")
				OS.center_window()
				window_change_action = false

			elif Globals.resolution == 2:
				window_change_action = true
				OS.window_fullscreen = false
				Globals.resolution = 3
				OS.window_size = Vector2(1920, 1080)
				yield(get_tree().create_timer(0.1), "timeout")
				OS.center_window()
				window_change_action = false

			elif Globals.resolution == 3:
				window_change_action = true
				OS.window_fullscreen = false
				Globals.resolution = 0
				OS.window_size = Vector2(960, 540)
				yield(get_tree().create_timer(0.1), "timeout")
				OS.center_window()
				window_change_action = false

			else:
				window_change_action = true
				OS.window_fullscreen = false
				Globals.resolution = 1
				OS.window_size = Vector2(1152, 648)
				yield(get_tree().create_timer(0.1), "timeout")
				OS.center_window()
				window_change_action = false

	elif Input.is_action_just_pressed("ui_focus_prev") and Globals.fkeys == true:
		var image : Image = get_viewport().get_texture().get_data()
		image.flip_y()
		image.save_png("res://screenshot.png")

	elif Input.is_action_just_pressed("ui_cancel"):
		Globals.speak = false

		if Globals.language == 0:
			Globals.language = 2
			Globals.saveValue("Values", "Sprache")
			get_tree().change_scene("res://Startscreen.tscn")

		elif winter_moving == true:
			Globals.ice_world_view = false
			get_tree().change_scene("res://Startscreen.tscn")

		elif Globals.roomnumber == 51:
			Globals.deathcount = 0
			Globals.saveValue("Values", "DeathCount")
			Globals.roomnumber = 0
			Globals.saveValue("Values", "Raumnummer")
			Globals.hardmode = false
			Globals.saveValue("Values", "HardMode")
			Globals.normal = false
			Globals.saveValue("Values", "Normal")
			Globals.music_chosen = false
			Globals.waytodestroysun = false
			get_tree().change_scene("res://Startscreen.tscn")

		else:
			get_tree().change_scene("res://Startscreen.tscn")

	elif Input.is_action_just_pressed("ui_focus_next"):
		Globals.speak = false
		get_tree().reload_current_scene()

	elif Input.is_action_just_pressed("game_information") and Globals.fkeys == true:

		if Globals.fps_show == true:
			Globals.fps_show = false

		else:
			Globals.fps_show = true

	elif Input.is_action_just_pressed("reset_save_menu") and Globals.fkeys == true:

		if Globals.language == 0:
			Globals.language = 2
			Globals.saveValue("Values", "Sprache")
			get_tree().change_scene("res://ConfirmationPanel.tscn")

		elif winter_moving == true:
			Globals.ice_world_view = false
			get_tree().change_scene("res://ConfirmationPanel.tscn")

		elif Globals.roomnumber == 51:
			Globals.deathcount = 0
			Globals.saveValue("Values", "DeathCount")
			Globals.roomnumber = 0
			Globals.saveValue("Values", "Raumnummer")
			Globals.hardmode = false
			Globals.saveValue("Values", "HardMode")
			Globals.normal = false
			Globals.saveValue("Values", "Normal")
			Globals.music_chosen = false
			Globals.waytodestroysun = false
			get_tree().change_scene("res://ConfirmationPanel.tscn")

		else:
			get_tree().change_scene("res://ConfirmationPanel.tscn")

	elif Input.is_action_just_pressed("quit_game") and Globals.fkeys == true:
		get_tree().quit()

	if motion.y < 0:
		$AnimatedSprite.play("Jumping")

	if Input.is_action_pressed("walk_left") and Input.is_action_pressed("walk_right"):
		motion.x = 0

		if winter_moving == false:
			$AnimatedSprite.play("Standing")

	elif Globals.speak == true:
		motion.x = 0
		motion.y = 350
		$AnimatedSprite.play("Standing")
		return

	elif Input.is_action_pressed("slow") and Input.is_action_pressed("walk_right") and winter_moving == false:
		motion.x = 50
		$AnimatedSprite.set_flip_h(false)
		$AnimatedSprite.play("Walking")

	elif Input.is_action_pressed("walk_right") and winter_moving == false:

		motion.x = walking_speed
		$AnimatedSprite.set_flip_h(false)
		$AnimatedSprite.play("Walking")

	elif Input.is_action_pressed("slow") and Input.is_action_pressed("walk_left") and winter_moving == false:
		motion.x = -50
		$AnimatedSprite.set_flip_h(true)
		$AnimatedSprite.play("Walking")

	elif Input.is_action_pressed("walk_left") and winter_moving == false:

		motion.x = walking_speed2
		$AnimatedSprite.set_flip_h(true)
		$AnimatedSprite.play("Walking")

	elif winter_moving == false:
		motion.x = 0
		$AnimatedSprite.play("Standing")

	if Input.is_action_just_pressed("ui_page_up"):

		if Globals.appearance != 3:
			Globals.appearance += 1

			if Globals.appearance == 1:
				$AnimatedSprite.set_self_modulate(Color(1, 1, 1, 0.25))

			elif Globals.appearance == 2:
				$AnimatedSprite.set_self_modulate(Color(0, 1, 1, 1))

			elif Globals.appearance == 3:
				$AnimatedSprite.set_self_modulate(Color(1, 1, 1, 0))

		else:
			Globals.appearance = 0
			$AnimatedSprite.set_self_modulate(Color(1, 1, 1, 1))

func apply_gravity():

	if motion.y == 123: #Gravity
		jumpkorrekt = true

	if position.y > 470: #LIMIT

		Globals.deathcount += 1
		Globals.saveValue("Values", "DeathCount")

		if Globals.hardmode == true and Globals.deathcount == 10:
			Globals.music_chosen = false
			Globals.waytodestroysun = false
			Globals.dreamer2sprech = false
			Globals.secretgreeter = false
			Globals.hardmode = false
			Globals.saveValue("Values", "HardMode")
			Globals.deathcount = 0
			Globals.saveValue("Values", "DeathCount")
			Globals.roomnumber = 0
			Globals.saveValue("Values", "Raumnummer")

			get_tree().change_scene("res://HardmodeFail.tscn")

		else:
			get_tree().reload_current_scene()

	elif is_on_floor() and motion.y > 0:
		jumpkorrekt = false
		motion.y = 0

	else:
		motion.y += 123

		if is_on_floor():
			return

func jump():

	if Globals.bunnyhop == true:

		if Input.is_action_pressed("space") and is_on_floor():

			if Globals.power == true:
				motion.y = -1350 #jumpspeed

				if Globals.speak == false and motion.y < 0 and Globals.soundsetting != 0:
					$AudioStreamPlayer1.play()

	else:

		if Input.is_action_just_pressed("space") and jumpkorrekt == false:

			if Globals.power == true:
				motion.y = -1350
				jumpkorrekt = true

				if Globals.speak == false and motion.y < 0 and Globals.soundsetting != 0:
					$AudioStreamPlayer1.play()

func camera():

	$Camera2D.rotation_degrees = 180

func camera2():

	$Camera2D.rotation_degrees = 0

func camera6():

	$Camera2D.rotation_degrees = 93

func camera7():

	$Camera2D.rotation_degrees = 183

func camera8():

	$Camera2D.rotation_degrees = 13

func _on_ChristmasMover_body_entered(_body : KinematicBody2D):

	winter_moving = true

func _on_Faster_body_entered(_body : KinematicBody2D):

	ice_moving += 1

	if ice_moving == 6:
		ice_move_speed = 1000

	else:
		ice_move_speed = ice_moving * 50 + 250
