extends Sprite

func _process(_delta : float) -> void:

	var collider : Array = $Area2D.get_overlapping_bodies()

	for object in collider:

		if object.name == "RedPlayer":

			object.queue_free()
			yield(get_tree().create_timer(1), "timeout")
			$RedX/AnimationPlayer.play("SunAnimation")
			Input.start_joy_vibration(0, 0.1, 0.1, 1.0)
			yield(get_tree().create_timer(1), "timeout")
			Input.start_joy_vibration(0, 0.3, 0.3, 1.0)
			yield(get_tree().create_timer(1), "timeout")
			Input.start_joy_vibration(0, 0.6, 0.6, 2.9)
			yield(get_tree().create_timer(3), "timeout")
			Input.stop_joy_vibration(0)
			Globals.destroyed = true
			Globals.saveValue("Values", "Destroyed")
			Globals.roomnumber = 51
			Globals.saveValue("Values", "Raumnummer")
			Globals.music_chosen = false
			Globals.speak = false
			get_tree().change_scene("res://Credits.tscn")
