extends Sprite

var TheManAtTheEnd : bool = false

func _on_Area2D_body_entered(_body : KinematicBody2D):

	if TheManAtTheEnd == false:

		if Globals.again_and_again == 0:

			if Globals.language == 1:

				TheManAtTheEnd = true
				Globals.speak = true
				$Label.text = "Du hast uns gefunden."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Dein Auftrag ist falsch."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Sie wollen die Sonne zurückbringen, um uns zu vernichten."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Es wird so heiß werden, dass alle, die hier leben, verbrennen."
				yield(get_tree().create_timer(6), "timeout")
				$Label.text = "Du wurdest auserwählt, um die Sonne zurückzubringen."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Aber du hast die Wahl."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Nimm die linke Tür und bring die Sonne zurück."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Nimm die rechte Tür, vernichte die Sonne und rette uns."
				yield(get_tree().create_timer(5), "timeout")
				Globals.speak = false
				$Label.text = "Entscheide."
				yield(get_tree().create_timer(3), "timeout")
				$Label.text = ""

			elif Globals.language == 2:

				TheManAtTheEnd = true
				Globals.speak = true
				$Label.text = "You've finally found us."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Your whole mission is a lie."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "If you bring back the sun, we’ll be annihilated."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "It would be so cruelly hot that we would burn to death."
				yield(get_tree().create_timer(6), "timeout")
				$Label.text = "You were chosen to bring back the sun."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "But you have a choice."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Choose the left door and bring back the sun."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Choose the right door, destroy the sun and save us."
				yield(get_tree().create_timer(5), "timeout")
				Globals.speak = false
				$Label.text = "Decide."
				yield(get_tree().create_timer(3), "timeout")
				$Label.text = ""

			elif Globals.language == 3:

				TheManAtTheEnd = true
				Globals.speak = true
				$Label.text = "Finalmente nos has encontrado."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Tu misión es una farsa."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Ellos quieren que recuperes el Sol para aniquilarnos."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Todo estaría tan caliente que arderíamos hasta morir."
				yield(get_tree().create_timer(6), "timeout")
				$Label.text = "Se te ha dicho que debes recuperar el Sol."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Pero puedes elegir."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Cruza la puerta izquierda y recupera el Sol."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Cruza la puerta derecha, destruye el Sol, y sálvanos."
				yield(get_tree().create_timer(5), "timeout")
				Globals.speak = false
				$Label.text = "Ahora decide."
				yield(get_tree().create_timer(3), "timeout")
				$Label.text = ""

			elif Globals.language == 5:

				TheManAtTheEnd = true
				Globals.speak = true
				$Label.text = "Você finalmente nos encontrou."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Sua missão inteira é uma mentira."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Se você trazer de volta o sol, nós seremos aniquilados."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Ficará tão cruelmente quente que vai queimar todos até a morte."
				yield(get_tree().create_timer(6), "timeout")
				$Label.text = "Você foi escolhido para trazer o sol de volta."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Mas você tem uma escolha."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Escolha a porta da esquerda e traga o sol de volta."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Escolha a porta da direita, destrua o sol e nos salve."
				yield(get_tree().create_timer(5), "timeout")
				Globals.speak = false
				$Label.text = "Agora decida."
				yield(get_tree().create_timer(3), "timeout")
				$Label.text = ""

			elif Globals.language == 7:

				TheManAtTheEnd = true
				Globals.speak = true
				$Label.text = "Tu encontraste-nos finalmente."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "A tua missão inteira é uma mentira."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Se tu trouxeres o sol de volta, serás aniquilado."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Será tão quente que vai queimar todos até à morte."
				yield(get_tree().create_timer(6), "timeout")
				$Label.text = "Tu foste escolhido para trazer o sol de volta."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Mas tu podes escolher."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Escolhe a porta da esquerda e traz o sol de volta."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Escolhe a porta da direita, destrói o sol e salvas-nos."
				yield(get_tree().create_timer(5), "timeout")
				Globals.speak = false
				$Label.text = "Agora decide."
				yield(get_tree().create_timer(3), "timeout")
				$Label.text = ""

			elif Globals.language == 8:

				TheManAtTheEnd = true
				Globals.speak = true
				$Label.text = "Finalmente nos has encontrado."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Tu misión es una farsa."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Ellos quieren que recuperes el Sol para aniquilarnos."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Todo estaría tan caliente que arderíamos hasta morir."
				yield(get_tree().create_timer(6), "timeout")
				$Label.text = "Se te ha dicho que debes recuperar el Sol."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Pero puedes elegir."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Cruza la puerta izquierda y recupera el Sol."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Cruza la puerta derecha, destruye el Sol, y sálvanos."
				yield(get_tree().create_timer(5), "timeout")
				Globals.speak = false
				$Label.text = "Ahora decide."
				yield(get_tree().create_timer(3), "timeout")
				$Label.text = ""

			elif Globals.language == 9:

				TheManAtTheEnd = true
				Globals.speak = true
				$Label.text = "Je hebt ons gevonden."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Jouw missie is verkeerd."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Ze willen de zon terugbrengen om ons te vernietigen."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Het zal zo vreselijk heet worden dat we allemaal zullen verbranden."
				yield(get_tree().create_timer(6), "timeout")
				$Label.text = "Je bent gekozen om de zon terug te brengen."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Maar je hebt een keuze."
				yield(get_tree().create_timer(4), "timeout")
				$Label.text = "Kies de linke deur en breng de zon terug."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = "Kies de rechte deur, vernietig de zon en red ons."
				yield(get_tree().create_timer(5), "timeout")
				Globals.speak = false
				$Label.text = "Neem een beslissing."
				yield(get_tree().create_timer(3), "timeout")
				$Label.text = ""

		elif Globals.again_and_again == 2:

			if Globals.language == 1:

				TheManAtTheEnd = true
				$Label.text = "Entscheide dich."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = ""

			elif Globals.language == 2:

				TheManAtTheEnd = true
				$Label.text = "Decide."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = ""

			elif Globals.language == 3:

				TheManAtTheEnd = true
				$Label.text = "Ahora decide."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = ""

			elif Globals.language == 5:

				TheManAtTheEnd = true
				$Label.text = "Agora decida."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = ""

			elif Globals.language == 7:

				TheManAtTheEnd = true
				$Label.text = "Agora decide."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = ""

			elif Globals.language == 8:

				TheManAtTheEnd = true
				$Label.text = "Ahora decide."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = ""

			elif Globals.language == 9:

				TheManAtTheEnd = true
				$Label.text = "Neem een beslissing."
				yield(get_tree().create_timer(5), "timeout")
				$Label.text = ""
