extends Sprite

#possibility, going down, not picking up the son, the son says: waaait!
#and if you go through without the son, the father is irritated

var first_spoken : int = 0
var brought: bool = false

func _process(_delta : float):

	if Globals.down_there == true:
		self.set_flip_h(true)

func _on_FrontArea_body_entered(_body : KinematicBody2D):

	if first_spoken == 0 or first_spoken == 2:

		first_spoken = 1

		if Globals.father_speak == false:
			Globals.speak = true
			Globals.father_speak = true

		if Globals.language == 1:

			$Label.text = "Mein Sohn ist dort unten."
			yield(get_tree().create_timer(3), "timeout")
			$Label.text = "Ich kann dort nicht runter. Ich würde sterben."
			yield(get_tree().create_timer(4), "timeout")
			$Label.text = "Du musst ihn zurückbringen!"
			Globals.speak = false
			yield(get_tree().create_timer(5), "timeout")
			$Label.text = ""

		elif Globals.language == 2:

			$Label.text = "My son is down there."
			yield(get_tree().create_timer(3), "timeout")
			$Label.text = "I can't go there.            I would die."
			yield(get_tree().create_timer(4), "timeout")
			$Label.text = "Bring Back The Son!"
			Globals.speak = false
			yield(get_tree().create_timer(5), "timeout")
			$Label.text = ""

		elif Globals.language == 3:

			$Label.text = "Mi hijo está allí abajo."
			yield(get_tree().create_timer(3), "timeout")
			$Label.text = "Yo no puedo ir. Podría morir."
			yield(get_tree().create_timer(4), "timeout")
			$Label.text = "¡Recupera a mi hijo!"
			Globals.speak = false
			yield(get_tree().create_timer(5), "timeout")
			$Label.text = ""

		elif Globals.language == 5:

			$Label.text = "Meu filho está lá embaixo."
			yield(get_tree().create_timer(3), "timeout")
			$Label.text = "Eu não posso ir até lá. Eu vou morrer."
			yield(get_tree().create_timer(4), "timeout")
			$Label.text = "Traga de Volta Meu Filho!"
			Globals.speak = false
			yield(get_tree().create_timer(5), "timeout")
			$Label.text = ""

		elif Globals.language == 7:

			$Label.text = "O meu filho está lá embaixo."
			yield(get_tree().create_timer(3), "timeout")
			$Label.text = "Eu não posso lá ir. Eu morreria."
			yield(get_tree().create_timer(4), "timeout")
			$Label.text = "Trás de Volta o Filho!"
			Globals.speak = false
			yield(get_tree().create_timer(5), "timeout")
			$Label.text = ""

		elif Globals.language == 8:

			$Label.text = "Mi hijo está allí abajo."
			yield(get_tree().create_timer(3), "timeout")
			$Label.text = "Yo no puedo ir. Podría morir."
			yield(get_tree().create_timer(4), "timeout")
			$Label.text = "¡Recupera a mi hijo!"
			Globals.speak = false
			yield(get_tree().create_timer(5), "timeout")
			$Label.text = ""

		elif Globals.language == 9:

			$Label.text = "Mijn zoon is daar beneden."
			yield(get_tree().create_timer(3), "timeout")
			$Label.text = "Ik kan er niet gaan. Ik zou sterven."
			yield(get_tree().create_timer(4), "timeout")
			$Label.text = "Breng mijn zoon terug!"
			Globals.speak = false
			yield(get_tree().create_timer(5), "timeout")
			$Label.text = ""

func _on_BackArea_body_entered(_body : KinematicBody2D):

	if brought == false:

		if Globals.kid_picked_up == false and Globals.down_there == true:

			brought = true

			if Globals.language == 1:
				$Label2.text = "Wo ist mein Sohn?!"

			elif Globals.language == 2:
				$Label2.text = "Where's my son?!"

			elif Globals.language == 3:
				$Label2.text = "¿Dónde está mi hijo?"

			elif Globals.language == 5:
				$Label2.text = "Onde está meu filho?"

			elif Globals.language == 7:
				$Label2.text = "Onde está o meu filho?"

			elif Globals.language == 8:
				$Label2.text = "¿Dónde está mi hijo?"

			elif Globals.language == 9:
				$Label2.text = "Waar is mijn zoon?"

		elif Globals.kid_picked_up == true and Globals.down_there == true:

			brought = true

			$KidStandingWithFather.visible = true
			Globals.kid_picked_up = false

			if Globals.ouch <= 3:

				if Globals.language == 1:
					$Label2.text = "Danke, dass du ihn zurückgebracht hast!"

				elif Globals.language == 2:
					$Label2.text = "Thank you, for bringing him back!"

				elif Globals.language == 3:
					$Label2.text = "¡Gracias por traerlo de regreso!"

				elif Globals.language == 5:
					$Label2.text = "Obrigado por trazê-lo de volta!"

				elif Globals.language == 7:
					$Label2.text = "Obrigado por o teres trazido de volta!"

				elif Globals.language == 8:
					$Label2.text = "¡Gracias por traerlo de regreso!"

				elif Globals.language == 9:
					$Label2.text = "Dank je wel, dat je hem terugbracht!"

			else:

				if Globals.language == 1:
					$Label2.text = "Oh, er ist verletzt!"

				elif Globals.language == 2:
					$Label2.text = "Oh, he's hurt!"

				elif Globals.language == 3:
					$Label2.text = "¡Oh, está herido!"

				elif Globals.language == 5:
					$Label2.text = "Oh, ele está machucado!"

				elif Globals.language == 7:
					$Label2.text = "Oh, ele está ferido!"

				elif Globals.language == 8:
					$Label2.text = "¡Oh, está herido!"

				elif Globals.language == 9:
					$Label2.text = "Oh, hij is gewond!"

func _on_HelpMeArea_body_entered(_body : KinematicBody2D):

	if first_spoken == 0:
		first_spoken = 2

		if Globals.language == 1:

			$Label.text = "Bitte, hilf mir!"
			yield(get_tree().create_timer(5), "timeout")

			if first_spoken == 0:
				$Label.text = ""
			#needed to prevent that the other text
			#will be cut off when the player decides to go to the father

		elif Globals.language == 2:

			$Label.text = "Please, help my son!"
			yield(get_tree().create_timer(5), "timeout")

			if first_spoken == 0:
				$Label.text = ""

		elif Globals.language == 3:

			$Label.text = "¡Por favor, salva a mi hijo!"
			yield(get_tree().create_timer(5), "timeout")

			if first_spoken == 0:
				$Label.text = ""

		elif Globals.language == 5:

			$Label.text = "Por favor, me ajude!"
			yield(get_tree().create_timer(5), "timeout")

			if first_spoken == 0:
				$Label.text = ""

		elif Globals.language == 7:

			$Label.text = "Por favor, ajuda o meu filho!"
			yield(get_tree().create_timer(5), "timeout")

			if first_spoken == 0:
				$Label.text = ""

		elif Globals.language == 8:

			$Label.text = "¡Por favor, salva a mi hijo!"
			yield(get_tree().create_timer(5), "timeout")

			if first_spoken == 0:
				$Label.text = ""

		elif Globals.language == 9:

			$Label.text = "Help me alstublieft!"
			yield(get_tree().create_timer(5), "timeout")

			if first_spoken == 0:
				$Label.text = ""
